# ../addons/eventscripts/corelib/damage/damage.py


# ==================================================
# >> IMPORTATIONS
# ==================================================


import es
import cmdlib
import weaponlib
import playerlib


# ==================================================
# >> INFORMATIONS
# ==================================================


__VERSION__ = "1.2d (2010-07-27)"


# ==================================================
# >> INITIALISATION
# ==================================================


def load():
   cmdlib.registerServerCommand("damage", ServerCommandCallBack, "Syntax: damage <target> <damage> [<type> [<source> [<weapon>]]]")
   
   
def unload():
   cmdlib.unregisterServerCommand("damage")
   
   
# ==================================================
# >> UTILITAIRES
# ==================================================


def GetPlayerList(string):
   returnValue = list()
   if (string.startswith("#") or string.startswith("!")) and (len(string) > 1):
      string = str(string).lower()
      if (string[1:] in playerlib.filters.keys()):
         returnValue = playerlib.getPlayerList(string)
   else:
      userid = es.getuserid(string)
      if es.exists("userid", userid):
         returnValue.append(playerlib.getPlayer(userid))
   return returnValue
   
   
def GetPlayerWeapon(userid, string):
   returnValue = None
   if es.exists("userid", userid):
      if (str(string).lower() == "#active"):
         weapon = es.createplayerlist(userid)[int(userid)]["weapon"]
         if (weapon != ""):
            returnValue = weapon
      elif str(string).isdigit() and (int(string) in xrange(1, 5)):
         handle = es.getplayerhandle(userid)
         for weapon in weaponlib.getWeaponList({1:"#primary", 2:"#secondary", 3:"#grenade", 4:"#knife"}[int(string)]):
            for index in weapon.indexlist:
               if (es.getindexprop(index, "CBaseEntity.m_hOwnerEntity") != handle):
                  continue
               returnValue = weapon
               break
   return returnValue
   
   
# ==================================================
# >> FONCTIONS D'APPEL
# ==================================================


def ServerCommandCallBack(arguments):
   if (len(arguments) >= 2):
      ignore = False
      if arguments[0].startswith("!") and (len(arguments[0]) > 1):
         ignore = True
         arguments[0] = arguments[0][1:]
      players = [x for x in GetPlayerList(arguments[0]) if not x.isdead]
      if not len(players):
         return
      index = es.createentity("point_hurt")
      es.entitysetvalue(index, "targetname", index)
      damage = arguments[1]
      if (damage.lower() == "#health"):
         damage = None
      else:
         es.entitysetvalue(index, "damage", damage)
      type = 32
      if (len(arguments) >= 3) and arguments[2].isdigit():
         type = arguments[2]
      es.entitysetvalue(index, "damagetype", type)
      source = None
      if (len(arguments) >= 4) and arguments[3].isdigit() and (int(arguments[3]) > 0):
         userid = es.getuserid(arguments[3])
         if es.exists("userid", userid):
            source = userid
      weapon = None
      if (len(arguments) >= 5):
         weapon = weaponlib.getWeapon(arguments[4])
         if not weapon and source:
            weapon = GetPlayerWeapon(source, arguments[4])
      if weapon:
         es.entitysetvalue(index, "classname", weapon)
      for player in players:
         if ignore and (str(player) == str(source)):
            continue
         targetname = es.entitygetvalue(player.index, "targetname")
         es.entitysetvalue(player.index, "targetname", player)
         activator = player
         if source:
            activator = source
         es.fire(activator, index, "addoutput", "damagetarget %i" % player)
         if not damage:
            es.fire(activator, index, "addoutput", "damage %i" % player.health)
         es.fire(activator, index, "hurt")
         es.fire(player, "!self", "addoutput", "targetname %s" % targetname)
      userid = es.getuserid()
      if userid:
         es.fire(userid, index, "kill")
   else:
      es.dbgmsg(0, "[Damage] Invalid syntax: damage <target> <damage> [<type> [<source> [<weapon>]]]")